set termout off;
SET NEWPAGE 0
SET SPACE 0
SET LINESIZE 200
SET PAGESIZE 0
SET ECHO OFF
SET FEEDBACK OFF
SET VERIFY OFF
SET HEADING OFF
SET MARKUP HTML OFF SPOOL OFF

SPOOL grant_privileges_read.sql

select 'GRANT SELECT, INSERT, UPDATE, DELETE ON "' || object_name || '" TO "' || (SELECT sys_context('USERENV', 'SESSION_USER') FROM DUAL) || '_R";'
  from ALL_OBJECTS
  where object_type in ('TABLE','VIEW')
    and owner = (SELECT sys_context('USERENV', 'SESSION_USER') FROM DUAL)
union
select 'GRANT SELECT ON "' || object_name || '" TO "' || (SELECT sys_context('USERENV', 'SESSION_USER') FROM DUAL) || '_R";'
  from ALL_OBJECTS
  where object_type in ('SEQUENCE')
    and owner = (SELECT sys_context('USERENV', 'SESSION_USER') FROM DUAL) 
union
select 'GRANT execute ON "' || object_name || '" TO "' || (SELECT sys_context('USERENV', 'SESSION_USER') FROM DUAL) || '_R";'
  from ALL_OBJECTS
  where object_type IN ('FUNCTION', 'PROCEDURE', 'PACKAGE')
  and owner = (SELECT sys_context('USERENV', 'SESSION_USER') FROM DUAL)
union
select 'GRANT execute ON "' || object_name || '" TO "' || (SELECT sys_context('USERENV', 'SESSION_USER') FROM DUAL) || '_R" WITH GRANT OPTION;'
  from ALL_OBJECTS
  where object_type IN ('TYPE')
  and owner = (SELECT sys_context('USERENV', 'SESSION_USER') FROM DUAL);

SPOOL grant_privileges_write.sql

select 'GRANT SELECT, INSERT, UPDATE, DELETE ON "' || object_name || '" TO "' || (SELECT sys_context('USERENV', 'SESSION_USER') FROM DUAL) || '_W";'
  from ALL_OBJECTS
  where object_type in ('TABLE','VIEW')
    and owner = (SELECT sys_context('USERENV', 'SESSION_USER') FROM DUAL)
union
select 'GRANT SELECT ON "' || object_name || '" TO "' || (SELECT sys_context('USERENV', 'SESSION_USER') FROM DUAL) || '_W";'
  from ALL_OBJECTS
  where object_type in ('SEQUENCE')
    and owner = (SELECT sys_context('USERENV', 'SESSION_USER') FROM DUAL) 
union
select 'GRANT execute ON "' || object_name || '" TO "' || (SELECT sys_context('USERENV', 'SESSION_USER') FROM DUAL) || '_W";'
  from ALL_OBJECTS
  where object_type IN ('FUNCTION', 'PROCEDURE', 'PACKAGE')
  and owner = (SELECT sys_context('USERENV', 'SESSION_USER') FROM DUAL)
union
select 'GRANT execute ON "' || object_name || '" TO "' || (SELECT sys_context('USERENV', 'SESSION_USER') FROM DUAL) || '_W" WITH GRANT OPTION;'
  from ALL_OBJECTS
  where object_type IN ('TYPE')
  and owner = (SELECT sys_context('USERENV', 'SESSION_USER') FROM DUAL);

SPOOL OFF

@grant_privileges_read.sql

@grant_privileges_write.sql

EXIT
